# $Revision: 1.83 $, $Date: 2009/01/27 14:01:15 $

%define		dataver	1.32b3-1
%define		snap	20081110
%define		rel		2
Summary:	Quake3 for Linux
Summary(de.UTF-8):	Quake3 für Linux
Summary(pl.UTF-8):	Quake3 dla Linuksa
Name:		quake3
Version:	1.35
Release:	0.%{snap}.%{rel}
License:	GPL v2
Group:		Applications/Games
Source0:	%{name}-%{snap}.tar.bz2
# Source0-md5:	65ed9787590bc043412c38b69c2c8521
Source2:	q3ded.init
Source3:	q3ded.sysconfig
Source4:	%{name}.desktop
Source5:	%{name}-smp.desktop
Patch0:		%{name}-QUAKELIBDIR.patch
Patch1:		%{name}-alpha.patch
URL:		http://ioquake3.org/
BuildRequires:	OpenAL-devel
BuildRequires:	OpenGL-devel
BuildRequires:	SDL-devel
BuildRequires:	curl-devel
BuildRequires:	libvorbis-devel
BuildRequires:	rpmbuild(macros) >= 1.268
#BuildRequires:	speex-devel
Requires:	%{name}-common = %{version}-%{release}
Requires:	OpenGL
Requires:	quake3-data >= %{dataver}
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

# source has been fixed to work without those
%define		filterout_c	-fwrapv -fno-strict-aliasing -fsigned-char

%define		specflags	-ffast-math -funroll-loops -fomit-frame-pointer
%define		x86_flags	-falign-loops=2 -falign-jumps=2 -falign-functions=2 -fstrength-reduce
%define		specflags_ia32	%{x86_flags}
%define		specflags_x86_64 %{x86_flags}
%define		specflags_amd64	%{x86_flags}
%define		specflags_ia32e	%{x86_flags}
%define		_noautoreqdep	libGL.so.1 libGLU.so.1

%description
Quake 3 for Linux.

%description -l de.UTF-8
Quake 3 für Linux.

%description -l pl.UTF-8
Quake 3 dla Linuksa.

%package server
Summary:	Quake3 server
Summary(de.UTF-8):	Quake3 Server
Summary(pl.UTF-8):	Serwer Quake3
Group:		Applications/Games
Requires(post,preun):	/sbin/chkconfig
Requires(postun):	/usr/sbin/groupdel
Requires(postun):	/usr/sbin/userdel
Requires(pre):	/bin/id
Requires(pre):	/usr/bin/getgid
Requires(pre):	/usr/sbin/groupadd
Requires(pre):	/usr/sbin/useradd
Requires(triggerpostun):	/usr/sbin/usermod
Requires:	%{name}-common = %{version}-%{release}
Requires:	psmisc
Requires:	rc-scripts
Requires:	screen
Provides:	group(quake3)
Provides:	user(quake3)

%description server
Quake3 server.

%description server -l de.UTF-8
Quake3 Server.

%description server -l pl.UTF-8
Serwer Quake3.

%package smp
Summary:	Quake3 for SMP
Summary(de.UTF-8):	Quake3 für SMP
Summary(pl.UTF-8):	Quake3 dla SMP
Group:		Applications/Games
Requires:	%{name}-common = %{version}-%{release}
Requires:	quake3-data >= %{dataver}

%description smp
Quake3 for multi processor machine.

%description smp -l de.UTF-8
Quake3 für Multiprocessor Rechner.

%description smp -l pl.UTF-8
Quake3 dla maszyny wieloprocesorowej.

%package common
Summary:	Common files for Quake3
Summary(de.UTF-8):	Gemeinsame Dateien für Quake3
Summary(pl.UTF-8):	Pliki wspólne dla Quake3
Group:		Applications/Games
Requires(triggerpostun):	/usr/sbin/groupdel
Requires(triggerpostun):	/usr/sbin/userdel
Obsoletes:	quake3-single

%description common
Common files for Quake3 server and player game.

%description common -l de.UTF-8
Gemeinsame Dateien für den Quake3 Server und das Spiel.

%description common -l pl.UTF-8
Pliki wspólne Quake3 dla serwera i trybu gracza.

%prep
%setup -q -n %{name}
%patch0 -p1
%patch1 -p1

%build
cat << 'EOF' > Makefile.local
BUILD_STANDALONE= 0
BUILD_CLIENT	= 1
# smp broken
BUILD_CLIENT_SMP= 0
BUILD_SERVER	= 1
BUILD_GAME_SO	= 1
BUILD_GAME_QVM	= 0
BUILD_MISSIONPACK= 1
USE_OPENAL	= 1
USE_OPENAL_DLOPEN = 0
USE_CURL	= 1
USE_CURL_DLOPEN = 0
USE_CODEC_VORBIS = 1
USE_MUMBLE	= 1
USE_VOIP	= 1
USE_INTERNAL_SPEEX = 1
USE_LOCAL_HEADERS = 0
GENERATE_DEPENDENCIES = 0

DEFAULT_BASEDIR = %{_datadir}/games/%{name}

override OPTIMIZE = %{rpmcflags} \
	-DQUAKELIBDIR=\\\"%{_libdir}/%{name}\\\"

# vim spec bug: "

override CC = %{__cc}
override LDFLAGS = %{rpmldflags}
override BR = rel

EOF

%{__make} release

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT/etc/{rc.d/init.d,sysconfig} \
	$RPM_BUILD_ROOT{%{_bindir},%{_datadir}/games/%{name}/baseq3} \
	$RPM_BUILD_ROOT%{_libdir}/%{name}/{baseq3,missionpack} \
	$RPM_BUILD_ROOT{%{_pixmapsdir},%{_desktopdir}} \
	$RPM_BUILD_ROOT/var/games/quake3

install rel/ioquake3.* $RPM_BUILD_ROOT%{_bindir}/%{name}
#install rel/ioquake3-smp.* $RPM_BUILD_ROOT%{_bindir}/%{name}-smp
install rel/ioq3ded.* $RPM_BUILD_ROOT%{_bindir}/q3ded

install rel/baseq3/*.so $RPM_BUILD_ROOT%{_libdir}/%{name}/baseq3
install rel/missionpack/*.so $RPM_BUILD_ROOT%{_libdir}/%{name}/missionpack

install %{SOURCE2} $RPM_BUILD_ROOT/etc/rc.d/init.d/q3ded
install %{SOURCE3} $RPM_BUILD_ROOT/etc/sysconfig/q3ded
install misc/%{name}.svg $RPM_BUILD_ROOT%{_pixmapsdir}
install %{SOURCE4} $RPM_BUILD_ROOT%{_desktopdir}/quake3.desktop
install %{SOURCE5} $RPM_BUILD_ROOT%{_desktopdir}/quake3-smp.desktop

%clean
rm -rf $RPM_BUILD_ROOT

%post common
if [ "$1" = "1" ]; then
	echo ""
	echo "You need to copy pak0.pk3 from your Quake3 CD into %{_datadir}/games/%{name}/baseq3/."
	echo "Or if you have got a Windows installation of Q3 make a symlink to save space."
	echo "You may place it in ~/.q3a/baseq3/ but you will have to put all pak files there (or make symlinks)."
	echo ""
fi

%pre server
%groupadd -P %{name}-server -g 38 quake3
%useradd -P %{name}-server -u 124 -d /var/games/quake3 -s /bin/sh -c "Quake ]|[ Arena" -g quake3 quake3

%post server
/sbin/chkconfig --add q3ded
%service q3ded restart "Quake3 server"

%preun server
if [ "$1" = "0" ]; then
	%service q3ded stop
	/sbin/chkconfig --del q3ded
fi

%postun server
if [ "$1" = "0" ]; then
	%userremove quake3
	%groupremove quake3
fi

%triggerpostun server -- %{name}-server < 1.33
if [ -f /var/lock/subsys/q3ded ]; then
	# server will fail because of lack of pak0.pk3
	/sbin/service q3ded stop 1>&2
fi
if [ "`getent passwd quake3 | cut -d: -f6`" = "/opt/quake3" ]; then
	/usr/sbin/usermod -d /var/games/quake3 -s /bin/sh quake3
fi

%triggerpostun common -- %{name}-common < 1.33
if [ ! -f %{_datadir}/games/%{name}/baseq3/pak0.pk3 ]; then
	# Better don't link/move automatically, /opt may be on other partition than /usr
	echo ""
	echo "Quake 3 data location has changed, link or move pak0.pk3 to %{_datadir}/games/%{name}/baseq3/."
	echo ""
fi

if [ "$1" = "0" ]; then
	%userremove quake3
	%groupremove quake3
fi

%files
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/quake3
%{_desktopdir}/quake3.desktop

%files common
%defattr(644,root,root,755)
%doc BUGS id-readme.txt README ChangeLog TODO
%dir %{_datadir}/games/%{name}
%dir %{_datadir}/games/%{name}/baseq3
%{_pixmapsdir}/quake3.svg
%dir %{_libdir}/%{name}
%dir %{_libdir}/%{name}/baseq3
%dir %{_libdir}/%{name}/missionpack
%attr(755,root,root) %{_libdir}/%{name}/baseq3/*.so
%attr(755,root,root) %{_libdir}/%{name}/missionpack/*.so

%files server
%defattr(644,root,root,755)
%attr(754,root,root) /etc/rc.d/init.d/q3ded
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) /etc/sysconfig/q3ded
%attr(755,root,root) %{_bindir}/q3ded
%attr(750,quake3,quake3) /var/games/quake3

%if 0
%files smp
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/quake3-smp
%{_desktopdir}/quake3-smp.desktop
%endif

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: quake3.spec,v $
Revision 1.83  2009/01/27 14:01:15  glen
- avoid dep loops (-common doesn't require -data now)

Revision 1.82  2008/11/10 14:45:50  sparky
- BR: curl-devel

Revision 1.81  2008/11/10 14:19:44  sparky
- up to 20081110 snap

Revision 1.80  2008/10/24 18:36:07  sparky
- fixed LDFLAGS

Revision 1.79  2008/10/24 16:13:38  sparky
- use svg icon

Revision 1.78  2008/10/24 16:02:56  sparky
- up to 20081024
- added some patches
- nicer build method
- smp is borked

Revision 1.77  2008/09/01 17:01:10  qboosh
- updated URL

Revision 1.76  2007/03/23 09:39:33  pluto
- gcc42 fixes.

Revision 1.75  2007/02/13 08:06:43  glen
- tabs in preamble

Revision 1.74  2007/02/12 01:06:30  baggins
- converted to UTF-8

Revision 1.73  2006/11/13 15:01:54  sparky
- don't use %{without ...}, it may not work after inverting bcond

Revision 1.72  2006/09/09 01:34:58  glen
- rel 2 (rebuild with fixed %useradd/%groupadd macros)

Revision 1.71  2006/08/16 22:06:43  jasw
- typo

Revision 1.70  2006/05/19 02:50:41  shadzik
- de

Revision 1.69  2006/04/03 20:44:42  sparky
- use supplied icon

Revision 1.68  2006/03/31 20:36:35  sparky
- up to 20060330

Revision 1.67  2006/03/13 23:27:51  glen
- use %service

Revision 1.66  2006/03/03 20:00:02  sparky
- snapshot updated, more docs

Revision 1.65  2006/02/26 20:59:47  pluto
- case.

Revision 1.64  2006/02/24 17:20:57  sparky
- snapshot uodared (revision 584)

Revision 1.63  2006/01/26 13:43:02  ankry
- rel. .1 STBR

Revision 1.62  2006/01/25 10:13:26  qboosh
- added alpha patch, now builds again

Revision 1.61  2006/01/24 01:54:18  sparky
- snapshot updated
- fixed build without openal
- altivec build works well now ! jit compiler for ppc isn't working yet

Revision 1.60  2006/01/24 00:45:58  sparky
- smp runs, don't know is it realy smp
- jit compiler works on amd64 !!

Revision 1.59  2006/01/24 00:24:27  sparky
- up to yesterdays snapshot (r518)
- smp client is back !
- rel 0.1 for now, I have to test it

Revision 1.58  2005/12/23 16:09:59  sparky
- updated to 20051221 (r446)
- added openal bcond

Revision 1.57  2005/12/05 16:49:36  sparky
- up to yesterdays snapshot

Revision 1.56  2005/11/20 03:09:48  sparky
- updated to yesterdays snapshot (added OpenAL support)

Revision 1.55  2005/11/13 18:52:34  sparky
- updated to yesterdays snapshot (almost nothing has changed)
- added altivec bcond (with -O3 -fsigned-char -mcpu=7400 -mtune=7400
  -Wa,-m7450 runs like a rocket on my iBook :] )

Revision 1.54  2005/11/06 19:46:55  sparky
- up to yesterdays snapshot
- build and install shared libraries
- web/include/status.php replaces STATUS, it's plain html file

Revision 1.53  2005/11/05 10:39:38  paszczus
- typo, spaces

Revision 1.52  2005/11/05 04:11:22  qboosh
- data moved, so no special license for -common

Revision 1.51  2005/11/04 22:03:46  sparky
- separated data
- O: smp in common (for now)
- some info in trigger
- rel 1, stbr (ac-test at last); status: ix86, x86_64, ppc works, other don't but builds

Revision 1.50  2005/11/04 19:55:22  sparky
- updated to yesterday snapshot (svn rev 252)
- fixed amd64, stupid vim syntax file, '#' in %ifnarch is not a comment

Revision 1.49  2005/11/01 11:29:10  sparky
- up to yesterday snapshot: q3ded works now on ppc, on sparc still don't
- works fine but still not rel 1, -smp is not done, maybe just add O: ?

Revision 1.48  2005/10/30 13:46:55  sparky
- changed VM_COMPILED confition

Revision 1.47  2005/10/30 01:57:20  sparky
- new snapshot: many, many cleanups
- as STATUS file says 3qded@ppc is not working

Revision 1.46  2005/10/28 15:41:16  sparky
- updated to 20051027 snap; game works pretty well on my iBook, server don't

Revision 1.45  2005/10/15 19:48:40  glen
- home dir cames from rpm. no need to create it

Revision 1.44  2005/10/15 19:44:06  sparky
- +BR: OpenGL-devel

Revision 1.43  2005/10/15 19:15:22  glen
- R for userdel
- fix files

Revision 1.42  2005/10/15 18:30:27  glen
- FHS: /var/games/quake3 and /usr/share/games/quake3
- finished triggers

Revision 1.41  2005/10/15 18:10:24  glen
- trigger (not tested)

Revision 1.40  2005/10/15 18:07:06  glen
- R: psmisc to -server
- tabs

Revision 1.39  2005/10/15 17:57:54  glen
- builds OK without byacc installed

Revision 1.38  2005/10/15 17:51:57  glen
- rpmmacros for *working* %useradd -m

Revision 1.37  2005/10/15 16:54:52  sparky
- I was wrong, su -c does nead shel

Revision 1.36  2005/10/15 16:18:19  sparky
- added TODO, i don't know how to do this as there has great mess in binary
- hot alpha fix patch: STBR ac-test

Revision 1.35  2005/10/15 15:31:06  sparky
- new snap, svn rev 162
- quake3 user neads no shell

Revision 1.34  2005/10/15 15:23:18  paszczus
- added -m option to useradd
- changed %{name}-common to %{name}-server in %pre (user/group add)
- release 0.6

Revision 1.33  2005/10/15 13:23:38  sparky
- icculus version now on HEAD, old branched as BINARY

Revision 1.16  2005/10/15 13:00:53  sparky
- quake3 user/group fixing finished
- TODO: clean upgrade from binary q3: quake3 home dir has changed

Revision 1.15  2005/10/15 10:36:21  paszczus
- Requires(post,preun,pre,postun) moved to -server package

Revision 1.14  2005/10/15 09:30:00  paszczus
- using new q3ded-gpl.init with new home directory (/usr/share/quake3-gpl)

Revision 1.13  2005/10/14 16:31:01  paszczus
- some docs added

Revision 1.12  2005/10/14 16:10:01  paszczus
- backiong to root.root for q3ded file

Revision 1.11  2005/10/14 13:28:02  paszczus
- chown quake3.quake3 for %{_bindir}/q3ded

Revision 1.10  2005/10/14 13:23:59  paszczus
- restored user/group add/remove but only for -server
- cleanup
- release 0.4

Revision 1.9  2005/10/14 06:51:17  paszczus
- fixed build on ppc (is it right way?)

Revision 1.8  2005/10/14 02:44:39  sparky
- many fixes, probably some bug introduced too:
- extract files from linuxq3apoint
- license of common is Q3A EULA, PB EULA
- commented out quake user/group stuff, what was it for ?
- use bindir/datadir and not gamedir
- -DDEFAULT_BASEDIR=\"%{_datadir}/%{name}\" fixes pak*.pk3 placement search
- -smp if broken for now
- TODO: check ppc/sparc; there is no alpha support; (re)add doc files; cleanups

Revision 1.7  2005/10/13 22:40:41  paszczus
- added BR: SDL-devel

Revision 1.6  2005/10/13 22:25:21  paszczus
- little cleanup
- changed _gamedir from /opt/quake3 to /usr/share/quake3

Revision 1.5  2005/10/13 22:11:50  paszczus
- missing files
- removed/commented some files

Revision 1.4  2005/10/13 22:06:23  paszczus
- used %{__make} copyfiles in %install
- added BR: sed >= 4.0 cause changed COPYFILES directory

Revision 1.3  2005/10/13 21:38:44  paszczus
- typo

Revision 1.2  2005/10/13 21:37:50  paszczus
- added BR: byacc

Revision 1.1  2005/10/13 21:36:29  paszczus
- initial spec file based on quake3.spec
- this is GPL version of great game Quake3
- NFY
